﻿#nullable enable

//------------------------------------------------------------------------------
// <auto-generated>
// This code was generated by:
//     DKX.Pg.AOT.Generators.EntityGenerator
// Changes to this file may cause incorrect behavior and
// will be lost if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace DKX.Pg.AOT.Tests.Samples.EntityGeneratorClasses
{
	public partial class PropertiesNotNullable
	{
		public PropertiesNotNullable(global::System.Data.IDataRecord record, int[] mapping)
		{
			Id = record.GetInt32(mapping[0]);
			BooleanProp = record.GetBoolean(mapping[1]);
			ByteProp = record.GetByte(mapping[2]);
			CharProp = record.GetChar(mapping[3]);
			DateTimeProp = record.GetDateTime(mapping[4]);
			DecimalProp = record.GetDecimal(mapping[5]);
			DoubleProp = record.GetDouble(mapping[6]);
			FloatProp = record.GetFloat(mapping[7]);
			GuidProp = record.GetGuid(mapping[8]);
			ShortProp = record.GetInt16(mapping[9]);
			IntProp = record.GetInt32(mapping[10]);
			LongProp = record.GetInt64(mapping[11]);
			StringProp = record.GetString(mapping[12]);
			ObjectProp = record.GetValue(mapping[13]);
			EnumProp = (global::DKX.Pg.AOT.Tests.Samples.EntityGeneratorClasses.PropertiesNotNullableSomeEnum)record.GetValue(mapping[14]);
			CompositeInterfaceProp = (global::DKX.Pg.AOT.Tests.Samples.EntityGeneratorClasses.IPropertiesNotNullableSomeComposite)record.GetValue(mapping[15]);
			CompositeProp = (global::DKX.Pg.AOT.Tests.Samples.EntityGeneratorClasses.PropertiesNotNullableSomeComposite)record.GetValue(mapping[16]);
			ArrayProp = (System.DateTime[])record.GetValue(mapping[17]);
		}
	}

	public sealed class PropertiesNotNullableEntityMetadata : global::DKX.Pg.Metadata.IEntityMetadata<PropertiesNotNullable>
	{
		public global::DKX.Pg.Metadata.IPropertyMetadata<PropertiesNotNullable>[] Properties { get; } = new global::DKX.Pg.Metadata.IPropertyMetadata<PropertiesNotNullable>[]
		{
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("Id", "id", true, false, entity => entity.Id),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("BooleanProp", "boolean_prop", false, false, entity => entity.BooleanProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("ByteProp", "byte_prop", false, false, entity => entity.ByteProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("CharProp", "char_prop", false, false, entity => entity.CharProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("DateTimeProp", "date_time_prop", false, true, entity => entity.DateTimeProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("DecimalProp", "decimal_prop", false, false, entity => entity.DecimalProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("DoubleProp", "double_prop", false, false, entity => entity.DoubleProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("FloatProp", "float_prop", false, false, entity => entity.FloatProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("GuidProp", "guid_prop", false, false, entity => entity.GuidProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("ShortProp", "short_prop", false, false, entity => entity.ShortProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("IntProp", "int_prop", false, false, entity => entity.IntProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("LongProp", "long_prop", false, false, entity => entity.LongProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("StringProp", "string_prop", false, false, entity => entity.StringProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("ObjectProp", "object_prop", false, false, entity => entity.ObjectProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("EnumProp", "enum_prop", false, false, entity => entity.EnumProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("CompositeInterfaceProp", "composite_interface_prop", false, false, entity => entity.CompositeInterfaceProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("CompositeProp", "composite_prop", false, false, entity => entity.CompositeProp),
			new global::DKX.Pg.Metadata.PropertyMetadata<PropertiesNotNullable>("ArrayProp", "array_prop", false, false, entity => entity.ArrayProp),
		};

		public int[] CreateMapping(global::System.Data.IDataRecord record)
		{
			return new int[]
			{
				record.GetOrdinal("id"),
				record.GetOrdinal("boolean_prop"),
				record.GetOrdinal("byte_prop"),
				record.GetOrdinal("char_prop"),
				record.GetOrdinal("date_time_prop"),
				record.GetOrdinal("decimal_prop"),
				record.GetOrdinal("double_prop"),
				record.GetOrdinal("float_prop"),
				record.GetOrdinal("guid_prop"),
				record.GetOrdinal("short_prop"),
				record.GetOrdinal("int_prop"),
				record.GetOrdinal("long_prop"),
				record.GetOrdinal("string_prop"),
				record.GetOrdinal("object_prop"),
				record.GetOrdinal("enum_prop"),
				record.GetOrdinal("composite_interface_prop"),
				record.GetOrdinal("composite_prop"),
				record.GetOrdinal("array_prop"),
			};
		}

		public PropertiesNotNullable CreateEntity(global::System.Data.IDataRecord record, int[] mapping)
		{
			return new PropertiesNotNullable(record, mapping);
		}
	}
}
